/*---------------------------------------------------------------------------------------------------------*/
/*                                                                                                         */
/* Copyright(c) 2009 Nuvoton Technology Corp. All rights reserved.                                         */
/*                                                                                                         */
/*---------------------------------------------------------------------------------------------------------*/
#include <stdio.h>
#include "NUC1xx.h"
#include "Driver\DrvGPIO.h"
#include "Driver\DrvUART.h"
#include "Driver\DrvSYS.h"

//                                +------------+
// GPIOA.0 -> Driver Board IN4 -> |            | -> Step Motor 28BYJ48 Blue wire
// GPIOA.1 -> Driver Board IN3 -> | Darlington | -> Step Motor 28BYJ48 Pink wire
// GPIOA.2 -> Driver Board IN2 -> |  ULN2003A  | -> Step Motor 28BYJ48 Yellow wire
// GPIOA.3 -> Driver Board IN1 -> |            | -> Step Motor 28BYJ48 Orange wire
//                                +------------+

// Step Motor: Ƕ = 5.625(deg)/64
#define d360    (4096)      // һΪ360,Ҫ4096һ
#define d180    (4096/2)    // 
#define d90     (4096/4)    // ķ֮һ
#define d45     (4096/8)    // ˷֮һ

// һ,༤
unsigned char CW[8]  = {0x08,0x0C,0x04,0x06,0x02,0x03,0x01,0x09}; // ת
unsigned char CCW[8] = {0x09,0x01,0x03,0x02,0x06,0x04,0x0c,0x08}; // ת

void CW_MOTOR(unsigned int deg)
{
    int i=0,j=0;

    for(j = 0; j < deg; j += 8)
    {
        for(i=0;i<8;i++)
        {
            GPIOA->DOUT=CW[i];
            DrvSYS_Delay(5000); //ʱ 5ms
        }
    }
}

void CCW_MOTOR(unsigned int deg)
{
    int i=0,j=0;

    for(j = 0; j < deg; j += 8)
    {
        for(i=0;i<8;i++)
        {
            GPIOA->DOUT=CCW[i];
            DrvSYS_Delay(5000); //ʱ 5ms
        }
    }
}

int main (void)
{
    CW_MOTOR(d360);     // ת360
    CCW_MOTOR(d180);    // ת180
    while(1);
}




